import Blender
import math
from Blender import Mathutils
from Blender.Mathutils import *
from Blender import Object, Scene

scn = Blender.Scene.GetCurrent()
scale = 1
render_all = False

cam = Blender.Object.GetSelected()[0]
if cam.type == "Camera":
	camName = cam.name
	matrix = cam.getMatrix()
	
	Il = Matrix([1,0,0,0],[0,1,0,0],[0,0,1,0],[-0.5*scale,0,0,1])
	Ir = Matrix([1,0,0,0],[0,1,0,0],[0,0,1,0],[0.5*scale,0,0,1])
	
	Blender.Object.Duplicate()
	camL = Blender.Object.GetSelected()[0]
	Blender.Object.Duplicate()
	camR = Blender.Object.GetSelected()[0]
	camL.name = camName + " Left"
	camR.name = camName + " Right"
	
	camL.setMatrix(Il * matrix)
	camR.setMatrix(Ir * matrix)
	
	dEmpty = Object.New("Empty", "Camera Rig")
	scn.link(dEmpty)
	dEmpty.setMatrix(matrix)
	cam.makeParent([camL,camR,dEmpty])

	scn.update(1)
	Blender.Redraw()
else:
	print "Please select a camera to duplicate"


if render_all:
	sce = Scene.GetCurrent()
	context = sce.getRenderingContext()
	output_path_orig = context.getRenderPath()
	
	cams = [ob for ob in sce.objects if ob.getType()=="Camera"]
	
	orig_cam = sce.objects.camera
	
	# loop over all the cameras in this scene, set active and render.
	for i, c in enumerate(cams):
		print "Rendering %i of %i cameras." % (i+1, len(cams))
		context.setRenderPath("%s%s_" % (output_path_orig, c.name))
		sce.setCurrentCamera(c)
		context.renderAnim()
		print "Done per camera render"
	
	if orig_cam:
		sce.setCurrentCamera(orig_cam)
		
	context.setRenderPath(output_path_orig)


